<?php

/**
 * @property $disciplines_collection  Model_Disciplines
 */

class Controller_Office_Disciplines extends Controller_Environment_Office {

    public function before() {
        parent::before();
        $this->user->checkAccess(User::RIGHTS_DEAN | User::RIGHTS_ADMIN);
        $this->disciplines_collection = new Model_Disciplines();
    }

    public function action_index() {
        $this->show_data(null);
    }

    public function action_filter() {
        $this->show_data($this->request->param('parameter'));
    }

    private function show_data($state, $semesterID = null){
        $semesterID = $semesterID ?: User::instance()->SemesterID;
        $facultyID = $this->user->Faculty->ID;
        $parameters = ['semesterID' => $semesterID, 'facultyID' => $facultyID];
        $disciplines = $this->disciplines_collection->setParamValues($parameters)
                                                    ->getByState($state);
        $teachers = [];
        foreach ($disciplines as $discipline) {
            $teachers[$discipline['ID']] = Model_Teacher::with($discipline['AuthorID']);
        }

        $this->twig->set_filename(self::OFFICE . 'disciplines/index')
            ->set([
                'Disciplines' => $disciplines,
                'Teachers'    => $teachers
            ]);

    }
}
